cookutils view cook @ rev 762

cooker.cgi: show browse button with broken packages
author Pascal Bellard <pascal.bellard@slitaz.org>
date Sun Sep 27 23:38:30 2015 +0200 (2015-09-27)
parents 050f39040fe4
children 30afd82dffb7
line source
1 #!/bin/sh
2 #
3 # Cook - A tool to cook and generate SliTaz packages. Read the README
4 # before adding or modifying any code in cook!
5 #
6 # Copyright (C) SliTaz GNU/Linux - GNU gpl v3
7 # Author: Christophe Lincoln <pankso@slitaz.org>
8 #
10 . /usr/lib/slitaz/libcook.sh
12 VERSION="3.2"
15 # Internationalization.
17 export TEXTDOMAIN='cook'
18 _() { local T="$1"; shift; printf "$(gettext "$T")" "$@"; echo; }
19 _n() { local T="$1"; shift; printf "$(gettext "$T")" "$@"; }
20 _p() {
21 local S="$1" P="$2" N="$3"; shift; shift; shift;
22 printf "$(ngettext "$S" "$P" "$N")" "$@"; }
25 #
26 # Functions
27 #
29 usage() {
30 cat <<EOT
32 $(boldify "$(_ 'Usage:')") $(_ 'cook [package|command] [list|--option]')
34 $(boldify "$(_ 'Commands:')")
35 usage|help $(_ 'Display this short usage.')
36 setup $(_ 'Setup your build environment.')
37 *-setup $(_ 'Setup a cross environment.')
38 * = {arm|armv6hf|armv7|x86_64}
39 test $(_ 'Test environment and cook a package.')
40 list-wok $(_ 'List packages in the wok.')
41 search $(_ 'Simple packages search function.')
42 new $(_ 'Create a new package with a receipt.')
43 list $(_ 'Cook a list of packages.')
44 clean-wok $(_ 'Clean-up all packages files.')
45 clean-src $(_ 'Clean-up all packages sources.')
46 uncook $(_ 'Check for uncooked packages')
47 pkgdb $(_ 'Create packages DB lists and flavors.')
49 $(boldify "$(_ 'Options:')")
50 cook <pkg>
51 --clean -c $(_ 'clean the package in the wok.')
52 --install -i $(_ 'cook and install the package.')
53 --getsrc -gs $(_ 'get the package source tarball.')
54 --block -b $(_ 'block a package so cook will skip it.')
55 --unblock -ub $(_ 'unblock a blocked package.')
56 --cdeps $(_ 'check dependencies of cooked package.')
57 --pack $(_ 'repack an already built package.')
58 --debug $(_ 'display debugging messages.')
59 --continue $(_ 'continue running compile_rules.')
60 cook new <pkg>
61 --interactive -x $(_ 'create a receipt interactively.')
62 cook setup
63 --wok $(_ 'clone the cooking wok from Hg repo.')
64 --stable $(_ 'clone the stable wok from Hg repo.')
65 --undigest $(_ 'clone the undigest wok from Hg repo.')
66 --tiny $(_ 'clone the tiny SliTaz wok from Hg repo.')
67 --forced $(_ 'force reinstall of chroot packages.')
68 cook pkgdb
69 --flavors $(_ 'create up-to-date flavors files.')
71 EOT
72 exit 0
73 }
76 # We don't want these escapes in web interface.
78 clean_log() {
79 sed -i -e s'|\[70G\[ \[1;32m| |' \
80 -e s'|\[0;39m \]||' $LOGS/$pkg.log
81 }
84 # Be sure package exists in wok.
86 check_pkg_in_wok() {
87 if [ ! -d "$WOK/$pkg" ]; then
88 newline; _ 'Unable to find package "%s" in the wok' "$pkg"; newline
89 exit 1
90 fi
91 }
94 if_empty_value() {
95 if [ -z "$value" ]; then
96 # L10n: QA is quality assurance
97 _ 'QA: empty variable: %s' "$var=\"\""; newline
98 exit 1
99 fi
100 }
103 # Initialize files used in $CACHE
105 init_db_files() {
106 _ 'Creating directories structure in "%s"' "$SLITAZ"
107 mkdir -p $WOK $PKGS $SRC $CACHE $LOGS $FEEDS
108 _ 'Creating DB files in "%s"' "$CACHE"
109 for f in $activity $command $broken $blocked; do
110 touch $f
111 done
112 }
115 # QA: check a receipt consistency before building.
117 receipt_quality() {
118 _ 'QA: checking package receipt...'
119 unset online
120 if ifconfig | grep -q -A 1 "^[a-z]*[0-9]" | fgrep 'addr:'; then
121 online='online'
122 fi
123 for var in PACKAGE VERSION CATEGORY SHORT_DESC MAINTAINER WEB_SITE; do
124 unset value
125 value="$(. $receipt; eval echo \$$var)"
126 case "$var" in
127 PACKAGE|VERSION|SHORT_DESC)
128 if_empty_value ;;
129 CATEGORY)
130 value="${value:-empty}"
131 valid="$(echo $PKGS_CATEGORIES)" # avoid newlines
132 if ! echo " $valid " | grep -q " $value "; then
133 _ 'QA: unknown category "%s"' "$value"
134 longline "$(_ 'Please, use one of: %s' "$valid")"
135 newline
136 exit 1
137 fi ;;
138 WEB_SITE)
139 # We don't check WGET_URL since if dl is needed it will fail.
140 # Break also if we're not online. Here error is not fatal.
141 if_empty_value
142 [ -z "$online" ] && break
143 if ! busybox wget -T 12 -s $value 2>/dev/null; then
144 _ 'QA: unable to reach "%s"' "$value"
145 fi ;;
146 esac
147 done
148 }
151 # Paths used in receipt and by cook itself.
153 set_paths() {
154 pkgdir="$WOK/$PACKAGE"
155 basesrc="$pkgdir/source"
156 tmpsrc="$basesrc/tmp"
157 src="$basesrc/$PACKAGE-$VERSION"
158 taz="$pkgdir/taz"
159 pack="$taz/$PACKAGE-$VERSION$EXTRAVERSION"
160 fs="$pack/fs"
161 stuff="$pkgdir/stuff"
162 install="$pkgdir/install"
163 pkgsrc="${SOURCE:-$PACKAGE}-${KBASEVER:-$VERSION}"
164 lzma_tarball="$pkgsrc.tar.lzma"
165 if [ -n "$PATCH" ]; then
166 [ -z "$PTARBALL" ] && PTARBALL="$(basename $PATCH)"
167 fi
168 if [ -n "$WANTED" ]; then
169 basesrc="$WOK/$WANTED/source"
170 src="$basesrc/$WANTED-$VERSION"
171 install="$WOK/$WANTED/install"
172 wanted_stuff="$WOK/$WANTED/stuff"
173 fi
174 if [ -n "$SOURCE" ]; then
175 source_stuff="$WOK/$SOURCE/stuff"
176 fi
177 # Kernel version is set from wok/linux or installed/linux-api-headers(wok-undigest)
178 if [ -f "$WOK/linux/receipt" ]; then
179 kvers=$(grep ^VERSION= $WOK/linux/receipt | cut -d\" -f2)
180 kbasevers=${kvers:0:3}
181 elif [ -f "$INSTALLED/linux-api-headers/receipt" ]; then
182 kvers=$(grep ^VERSION= $INSTALLED/linux-api-headers/receipt | cut -d\" -f2)
183 kbasevers=${kvers:0:3}
184 fi
185 # Python version
186 if [ -f "$WOK/python/receipt" ]; then
187 pyvers=$(grep ^VERSION= $WOK/python/receipt | cut -d\" -f2)
188 fi
189 # Perl version for some packages needed it
190 if [ -f "$WOK/perl/receipt" ]; then
191 perlvers=$(grep ^VERSION= $WOK/perl/receipt | cut -d\" -f2)
192 fi
193 # Old way compatibility.
194 _pkg="$install"
195 }
198 # Create source tarball when URL is a SCM.
200 create_tarball() {
201 local tarball
202 tarball="$pkgsrc.tar.bz2"
203 [ -n "$LZMA_SRC" ] && tarball="$lzma_tarball"
204 _ 'Creating tarball "%s"' "$tarball"
205 if [ -n "$LZMA_SRC" ]; then
206 tar -c $pkgsrc | lzma e $SRC/$tarball -si $LZMA_SET_DIR || exit 1
207 LZMA_SRC=''
208 else
209 tar -cjf $tarball $pkgsrc || exit 1
210 mv $tarball $SRC; rm -rf $pkgsrc
211 fi
212 TARBALL="$tarball"
213 }
216 # Get package source. For SCM we are in cache so clone here and create a
217 # tarball here.
219 get_source() {
220 local url
221 url="$MIRROR_URL/sources/packages/${TARBALL:0:1}/$TARBALL"
222 set_paths
223 pwd=$(pwd)
224 case "$WGET_URL" in
225 http://*|ftp://*)
226 # Busybox Wget is better!
227 busybox wget -T 60 -c -O $SRC/$TARBALL $WGET_URL || \
228 busybox wget -T 60 -c -O $SRC/$TARBALL $url || \
229 (_ 'ERROR: %s' "wget $WGET_URL" && exit 1) ;;
231 https://*)
232 wget -c --no-check-certificate -O $SRC/$TARBALL $WGET_URL || \
233 busybox wget -T 60 -c -O $SRC/$TARBALL $url || \
234 (_ 'ERROR: %s' "wget $WGET_URL" && exit 1) ;;
236 hg*|mercurial*)
237 if $(echo "$WGET_URL" | fgrep -q 'hg|'); then
238 url=${WGET_URL#hg|}
239 else
240 url=${WGET_URL#mercurial|}
241 fi
242 _ 'Getting source from %s...' 'Hg'
243 _ 'URL: %s' "$url"
244 _ 'Cloning to "%s"' "$pwd/$pkgsrc"
245 if [ -n "$BRANCH" ]; then
246 _ 'Hg branch: %s' "$BRANCH"
247 hg clone $url --rev $BRANCH $pkgsrc || \
248 (_ 'ERROR: %s' "hg clone $url --rev $BRANCH" && exit 1)
249 else
250 hg clone $url $pkgsrc || (_ 'ERROR: %s' "hg clone $url" && exit 1)
251 fi
252 rm -rf $pkgsrc/.hg
253 create_tarball ;;
255 git*)
256 url=${WGET_URL#git|}
257 _ 'Getting source from %s...' 'Git'
258 _ 'URL: %s' "$url"
259 cd $SRC
260 git clone $url $pkgsrc || (_ 'ERROR: %s' "git clone $url" && exit 1)
261 if [ -n "$BRANCH" ]; then
262 _ 'Git branch: %s' "$BRANCH"
263 cd $pkgsrc; git checkout $BRANCH; cd ..
264 fi
265 cd $SRC
266 create_tarball ;;
268 cvs*)
269 url=${WGET_URL#cvs|}
270 mod=$PACKAGE
271 [ -n "$CVS_MODULE" ] && mod=$CVS_MODULE
272 _ 'Getting source from %s...' 'CVS'
273 _ 'URL: %s' "$url"
274 [ -n "$CVS_MODULE" ] && _ 'CVS module: %s' "$mod"
275 _ 'Cloning to "%s"' "$pwd/$mod"
276 cvs -d:$url co $mod && mv $mod $pkgsrc
277 create_tarball ;;
279 svn*|subversion*)
280 if $(echo "$WGET_URL" | fgrep -q "svn|"); then
281 url=${WGET_URL#svn|}
282 else
283 url=${WGET_URL#subversion|}
284 fi
285 _ 'Getting source from %s...' 'SVN'
286 _ 'URL: %s' "$url"
287 if [ -n "$BRANCH" ]; then
288 echo t | svn co $url -r $BRANCH $pkgsrc
289 else
290 echo t | svn co $url $pkgsrc
291 fi
292 create_tarball ;;
294 bzr*)
295 url=${WGET_URL#bzr|}
296 _ 'Getting source from %s...' 'bazaar'
297 cd $SRC
298 pkgsrc=${url#*:}
299 if [ -n "$BRANCH" ]; then
300 echo "bzr -Ossl.cert_reqs=none branch $url -r $BRANCH"
301 bzr -Ossl.cert_reqs=none branch $url -r $BRANCH
302 else
303 echo "bzr -Ossl.cert_reqs=none branch $url"
304 bzr -Ossl.cert_reqs=none branch $url
305 cd $pkgsrc; BRANCH=$(bzr revno); cd ..
306 _ "Don't forget to add to receipt:"
307 echo -e "BRANCH=\"$BRANCH\"\n"
308 fi
309 mv $pkgsrc $pkgsrc-$BRANCH
310 pkgsrc="$pkgsrc-$BRANCH"
311 create_tarball ;;
313 *)
314 (newline; _ 'ERROR: Unable to handle "%s"' "$WGET_URL"; newline) | \
315 tee -a $LOGS/$PACKAGE.log
316 exit 1 ;;
317 esac
318 }
321 # Extract source package.
323 extract_source() {
324 if [ ! -s "$SRC/$TARBALL" ]; then
325 local url
326 url="$MIRROR_URL/sources/packages"
327 url="$url/${TARBALL:0:1}/$TARBALL"
328 _ 'Getting source from %s...' 'mirror'
329 _ 'URL: %s' "$url"
330 busybox wget -c -P $SRC $url || _ 'ERROR: %s' "wget $url"
331 fi
332 _ 'Extracting source archive "%s"' "$TARBALL"
333 case "$TARBALL" in
334 *.tar.gz|*.tgz) tar -xzf $SRC/$TARBALL 2>/dev/null ;;
335 *.tar.bz2|*.tbz|*.tbz2) tar -xjf $SRC/$TARBALL 2>/dev/null ;;
336 *.tar.lzma) tar -xaf $SRC/$TARBALL ;;
337 *.tar.lz|*.tlz) lzip -d < $SRC/$TARBALL | tar -xf - 2>/dev/null ;;
338 *.tar) tar -xf $SRC/$TARBALL ;;
339 *.zip|*.xpi) unzip -o $SRC/$TARBALL ;;
340 *.xz) unxz -c $SRC/$TARBALL | tar -xf - || \
341 tar -xf $SRC/$TARBALL 2>/dev/null;;
342 *.7z) 7zr x $SRC/$TARBALL ;;
343 *.Z|*.z) uncompress -c $SRC/$TARBALL | tar -xf - ;;
344 *.rpm) rpm2cpio $SRC/$TARBALL | cpio -idm --quiet ;;
345 *.run) /bin/sh $SRC/$TARBALL $RUN_OPTS ;;
346 *) cp $SRC/$TARBALL $(pwd) ;;
347 esac
348 }
351 # Display cooked package summary.
353 summary() {
354 cd $WOK/$pkg
355 [ -d $WOK/$pkg/install ] && prod=$(du -sh $WOK/$pkg/install | awk '{print $1}' 2>/dev/null)
356 [ -d $WOK/$pkg/source ] && srcdir=$(du -sh $WOK/$pkg/source | awk '{print $1}' 2>/dev/null)
357 fs=$(du -sh $WOK/$pkg/taz/* | awk '{print $1}')
358 size=$(du -sh $PKGS/$pkg-${VERSION}*.tazpkg | awk '{print $1}')
359 files=$(cat $WOK/$pkg/taz/$pkg-*/files.list | wc -l)
360 [ -n "$TARBALL" ] && srcsize=$(du -sh $SRC/$TARBALL | awk '{print $1}')
362 sec="$time"
363 div=$(( ($time + 30) / 60))
364 case $div in
365 0) min='';;
366 # L10n: 'm' is for minutes (approximate cooking time)
367 *) min=$(_n '~ %dm' "$div");;
368 esac
370 _ 'Summary for: %s' "$PACKAGE $VERSION"
371 separator
373 # L10n: keep the same width of translations to get a consistent view
374 [ -n "$srcdir" ] && _ 'Source dir : %s' "$srcdir"
375 [ -n "$TARBALL" ] && _ 'Src file : %s' "$TARBALL"
376 [ -n "$srcsize" ] && _ 'Src size : %s' "$srcsize"
377 [ -n "$prod" ] && _ 'Produced : %s' "$prod"
378 _ 'Packed : %s' "$fs"
379 _ 'Compressed : %s' "$size"
380 _ 'Files : %s' "$files"
381 # L10n: 's' is for seconds (cooking time)
382 _ 'Cook time : %ds %s' "$sec" "$min"
383 _ 'Cook date : %s' "$(date "$(_ '+%%F %%R')")"
384 _ 'Host arch : %s' "$ARCH"
385 separator
386 }
389 # Display debugging error info.
391 debug_info() {
392 newline; _ 'Debug information'; separator
393 # L10n: specify your format of date and time (to help: man date)
394 # L10n: not bad one is '+%x %R'
395 _ 'Cook date: %s' "$(date "$(_ '+%%F %%R')")"
396 [ "$time" ] && _ 'Cook time: %ds' "$(($(date +%s) - $time))"
397 # L10n: Please, translate all messages beginning with ERROR in a same way
398 lerror=$(_n 'ERROR')
399 for error in \
400 ERROR $lerror 'No package' "cp: can't" "can't open" "can't cd" \
401 'error:' 'fatal error:' 'undefined reference to' \
402 'Unable to connect to' 'link: cannot find the library' \
403 'CMake Error' ': No such file or directory'
404 do
405 fgrep "$error" $LOGS/$pkg.log
406 done > $LOGS/$pkg.log.debug_info 2>&1
407 cat $LOGS/$pkg.log.debug_info
408 rm -f $LOGS/$pkg.log.debug_info
409 separator; newline
410 }
413 # Copy all generic files (locale, pixmaps, .desktop). We use standard paths,
414 # so some packages need to copy these files with the receipt and genpkg_rules.
416 copy_generic_files() {
417 # $LOCALE is set in cook.conf
418 if [ -n "$LOCALE" -a -z "$WANTED" ]; then
419 if [ -d "$install/usr/share/locale" ]; then
420 mkdir -p $fs/usr/share/locale
421 for i in $LOCALE; do
422 if [ -d "$install/usr/share/locale/$i" ]; then
423 cp -a $install/usr/share/locale/$i $fs/usr/share/locale
424 fi
425 done
426 fi
427 fi
429 # Generic pixmaps copy can be disabled with GENERIC_PIXMAPS="no"
430 if [ "$GENERIC_PIXMAPS" != 'no' ]; then
431 if [ -d "$install/usr/share/pixmaps" ]; then
432 mkdir -p $fs/usr/share/pixmaps
433 if [ -f "$install/usr/share/pixmaps/$PACKAGE.png" ]; then
434 cp -a $install/usr/share/pixmaps/$PACKAGE.png \
435 $fs/usr/share/pixmaps
436 elif [ -f "$install/usr/share/pixmaps/$PACKAGE.xpm" ]; then
437 cp -a $install/usr/share/pixmaps/$PACKAGE.xpm \
438 $fs/usr/share/pixmaps
439 fi
440 fi
442 # Custom or homemade PNG pixmap can be in stuff.
443 if [ -f "$stuff/$PACKAGE.png" ]; then
444 mkdir -p $fs/usr/share/pixmaps
445 cp -a $stuff/$PACKAGE.png $fs/usr/share/pixmaps
446 fi
447 fi
449 # Desktop entry (.desktop).
450 # Generic desktop entry copy can be disabled with GENERIC_MENUS="no"
451 if [ "$GENERIC_MENUS" != 'no' ]; then
452 if [ -d "$install/usr/share/applications" ] && [ -z "$WANTED" ]; then
453 mkdir -p $fs/usr/share
454 cp -a $install/usr/share/applications $fs/usr/share
455 fi
456 fi
458 # Homemade desktop file(s) can be in stuff.
459 if [ -d "$stuff/applications" ]; then
460 mkdir -p $fs/usr/share
461 cp -a $stuff/applications $fs/usr/share
462 fi
463 if [ -f "$stuff/$PACKAGE.desktop" ]; then
464 mkdir -p $fs/usr/share/applications
465 cp -a $stuff/$PACKAGE.desktop $fs/usr/share/applications
466 fi
468 # Add custom licenses
469 if [ -d "$stuff/licenses" ]; then
470 mkdir -p $fs/usr/share/licenses
471 cp -a $stuff/licenses $fs/usr/share/licenses/$PACKAGE
472 fi
473 }
476 # Find and strip: --strip-all (-s) or --strip-debug on static libs as well
477 # as removing unneeded files like in Python packages. Cross compiled binaries
478 # must be stripped with cross-tools aka $ARCH-slitaz-*-strip
480 strip_package() {
481 case "$ARCH" in
482 arm*|x86_64) export STRIP="$HOST_SYSTEM-strip" ;;
483 *) export STRIP='strip' ;;
484 esac
485 _n 'Executing strip on all files...'
486 for dir in $fs/bin $fs/sbin $fs/usr/bin $fs/usr/sbin $fs/usr/games; do
487 if [ -d "$dir" ]; then
488 find $dir -type f -exec $STRIP -s '{}' 2>/dev/null \;
489 fi
490 done
491 find $fs -name '*.so*' -exec $STRIP -s '{}' 2>/dev/null \;
492 find $fs -name '*.a' -exec $STRIP --strip-debug '{}' 2>/dev/null \;
493 status
495 # Remove Python .pyc and .pyo from packages.
496 #_n 'Removing Python compiled files...'
497 find $fs -type f \( -name '*.pyc' -o -name '*.pyo' \) -delete 2>/dev/null
498 #status
500 # Remove Perl perllocal.pod and .packlist from packages.
501 #_n 'Removing Perl compiled files...'
502 find $fs -type f \( -name 'perllocal.pod' -o -name '.packlist' \) -delete 2>/dev/null
503 #status
504 }
507 # Remove installed deps.
509 remove_deps() {
510 # Now remove installed build deps.
511 diff='/tmp/installed.cook.diff'
512 if [ -s $diff ]; then
513 deps=$(cat $diff | grep ^+[a-zA-Z0-9] | sed s/^+//)
514 nb=$(cat $diff | grep ^+[a-zA-Z0-9] | wc -l)
515 _n 'Build dependencies to remove:'; echo " $nb"
516 [ -n "$root" ] && echo "root=\"$root\""
517 _n 'Removing:'
518 for dep in $deps; do
519 echo -n " $dep"
520 echo 'y' | tazpkg remove $dep --root=$root >/dev/null
521 done
522 newline; newline
523 # Keep the last diff for debug and info.
524 mv -f $diff $CACHE/installed.diff
525 fi
526 }
529 # The main cook function.
531 cookit() {
532 _ 'Cook: %s' "$PACKAGE $VERSION"; separator
533 set_paths
535 # Handle cross-tools.
536 case "$ARCH" in
537 arm*|x86_64)
538 # CROSS_COMPILE is used by at least Busybox and the kernel to set
539 # the cross-tools prefix. Sysroot is the root of our target arch
540 sysroot="$CROSS_TREE/sysroot"
541 tools="$CROSS_TREE/tools"
542 # Set root path when cross compiling. ARM tested but not x86_64
543 # When cross compiling we must install build deps in $sysroot.
544 arch="-$ARCH"
545 root="$sysroot"
546 _ '%s sysroot: %s' "$ARCH" "$sysroot"
547 _ 'Adding "%s" to PATH' "$tools/bin"
548 export PATH="$PATH:$tools/bin"
549 export PKG_CONFIG_PATH="$sysroot/usr/lib/pkgconfig"
550 export CROSS_COMPILE="$HOST_SYSTEM-"
551 _ 'Using cross-tools: %s' "$CROSS_COMPILE"
552 if [ "$ARCH" == 'x86_64' ]; then
553 export CC="$HOST_SYSTEM-gcc -m64"
554 export CXX="$HOST_SYSTEM-g++ -m64"
555 else
556 export CC="$HOST_SYSTEM-gcc"
557 export CXX="$HOST_SYSTEM-g++"
558 fi
559 export AR="$HOST_SYSTEM-ar"
560 export AS="$HOST_SYSTEM-as"
561 export RANLIB="$HOST_SYSTEM-ranlib"
562 export LD="$HOST_SYSTEM-ld"
563 export STRIP="$HOST_SYSTEM-strip"
564 export LIBTOOL="$HOST_SYSTEM-libtool" ;;
565 esac
567 [ -n "$QA" ] && receipt_quality
568 cd $pkgdir
569 [ -z "$continue" ] && rm -rf source 2>/dev/null
570 rm -rf install taz 2>/dev/null
572 # Disable -pipe if less than 512Mb free RAM.
573 free=$(free | awk '/buffers:/{print $4}')
574 if [ "$free" -lt 524288 ] && [ "$CFLAGS" != "${CFLAGS/-pipe}" ]; then
575 _ 'Disabling -pipe compile flag: %d RAM free' "$free"
576 CFLAGS="${CFLAGS/-pipe}"; CFLAGS=$(echo "$CFLAGS" | tr -s ' ')
577 CXXFLAGS="${CXXFLAGS/-pipe}"; CXXFLAGS=$(echo "$CXXFLAGS" | tr -s ' ')
578 fi
579 unset free
581 # Export flags and path to be used by make and receipt.
582 DESTDIR="$pkgdir/install"
583 # FIXME: L10n: Is this the right time for 'LC_ALL=C LANG=C'?
584 export DESTDIR MAKEFLAGS CFLAGS CXXFLAGS CONFIG_SITE LC_ALL=C LANG=C
585 #LDFLAGS
587 # Check for build deps and handle implicit depends of *-dev packages
588 # (ex: libusb-dev :: libusb).
589 rm -f $CACHE/installed.local $CACHE/installed.web $CACHE/missing.dep
590 touch $CACHE/installed.local $CACHE/installed.web
591 [ -n "$BUILD_DEPENDS" ] && _ 'Checking build dependencies...'
592 [ -n "$root" ] && _ 'Using packages DB: %s' "$root$DB"
593 for dep in $BUILD_DEPENDS; do
594 implicit="${dep%-dev}"
595 for i in $dep $implicit; do
596 if [ ! -f "$root$INSTALLED/$i/receipt" ]; then
597 # Try local package first. In some cases implicit doesn't exist, ex:
598 # libboost-dev exists but not libboost, so check if we got vers.
599 unset vers
600 vers=$(. $WOK/$i/receipt 2>/dev/null ; echo $VERSION)
601 # We may have a local package.
602 if [ -z "$vers" ]; then
603 vers=$(awk -F$'\t' -vp="$i" '$1==p{print $2; quit}' $PKGS/packages.info)
604 fi
605 debug "bdep: $i version: $vers"
606 if [ -f "$PKGS/$i-$vers$arch.tazpkg" ]; then
607 echo $i-$vers$arch.tazpkg >> $CACHE/installed.local
608 else
609 # Priority to package version in wok (maybe more up-to-date)
610 # than the mirrored one.
611 if [ -n "$vers" ]; then
612 if fgrep -q $i-$vers$arch $root$DB/packages.list; then
613 echo $i >> $CACHE/installed.web
614 else
615 # So package exists in wok but not available.
616 _ 'Missing dep (wok/pkg): %s' "$i $vers"
617 echo $i >> $CACHE/missing.dep
618 fi
619 else
620 # Package is not in wok but may be in online repo.
621 if fgrep -q $i-$vers$arch $root$DB/packages.list; then
622 echo $i >> $CACHE/installed.web
623 else
624 _ 'ERROR: unknown dep "%s"' "$i"
625 exit 1
626 fi
627 fi
628 fi
629 fi
630 done
631 done
633 # Get the list of installed packages
634 cd $root$INSTALLED; ls -1 > $CACHE/installed.list
636 # Have we a missing build dep to cook?
637 if [ -s "$CACHE/missing.dep" ] && [ -n "$AUTO_COOK" ]; then
638 _ 'Auto cook config is set: %s' "$AUTO_COOK"
639 cp -f $LOGS/$PACKAGE.log $LOGS/$PACKAGE.log.$$
640 for i in $(uniq $CACHE/missing.dep); do
641 (_ 'Building dep (wok/pkg) : %s' "$i $vers") | \
642 tee -a $LOGS/$PACKAGE.log.$$
643 # programmers: next two messages are exact copy from remove_deps()
644 togrep1=$(_n 'Build dependencies to remove:')
645 togrep2=$(_n 'Removing:')
646 cook $i || (_ "ERROR: can't cook dep \"%s\"" "$i" && newline && \
647 fgrep $togrep1 $LOGS/$i.log && \
648 fgrep $togrep2 $LOGS/$i.log && newline) | \
649 tee -a $LOGS/$PACKAGE.log.$$ && break
650 done
651 rm -f $CACHE/missing.dep
652 mv $LOGS/$PACKAGE.log.$$ $LOGS/$PACKAGE.log
653 fi
655 # QA: Exit on missing dep errors. We exit in both cases, if AUTO_COOK
656 # is enabled and cook fails we have ERROR in log, if no auto cook we have
657 # missing dep in cached file.
658 lerror=$(_n 'ERROR')
659 if fgrep -q ^$lerror $LOGS/$pkg.log || [ -s "$CACHE/missing.dep" ]; then
660 [ -s "$CACHE/missing.dep" ] && nb=$(cat $CACHE/missing.dep | wc -l)
661 _p 'ERROR: missing %d dependency' 'ERROR: missing %d dependencies' "$nb" "$nb"
662 exit 1
663 fi
665 # Install local packages: package-version$arch
666 cd $PKGS
667 for i in $(uniq $CACHE/installed.local); do
668 _ 'Installing dep (pkg/local): %s' "$i"
669 tazpkg install $i --root=$root >/dev/null
670 done
672 # Install web or cached packages (if mirror is set to $PKGS we only
673 # use local packages).
674 for i in $(uniq $CACHE/installed.web); do
675 _ 'Installing dep (web/cache): %s' "$i"
676 tazpkg get-install $i --root=$root >/dev/null
677 done
679 # If a cook failed deps are removed.
680 cd $root$INSTALLED; ls -1 > $CACHE/installed.cook
681 cd $CACHE
682 [ ! -s '/tmp/installed.cook.diff' ] && \
683 busybox diff installed.list installed.cook > /tmp/installed.cook.diff
684 deps=$(cat /tmp/installed.cook.diff | grep ^+[a-zA-Z0-9] | wc -l)
686 # Get source tarball and make sure we have source dir named:
687 # $PACKAGE-$VERSION to be standard in receipts. Here we use tar.lzma
688 # tarball if it exists.
689 if [ -n "$WGET_URL" ] && [ ! -f "$SRC/$TARBALL" ]; then
690 if [ -f "$SRC/${SOURCE:-$PACKAGE}-$VERSION.tar.lzma" ]; then
691 TARBALL="${SOURCE:-$PACKAGE}-$VERSION.tar.lzma"
692 LZMA_SRC=''
693 else
694 get_source || exit 1
695 fi
696 fi
697 if [ -z "$WANTED" ] && [ -n "$TARBALL" ] && [ ! -d "$src" ]; then
698 mkdir -p $pkgdir/source/tmp; cd $pkgdir/source/tmp
699 if ! extract_source ; then
700 get_source
701 extract_source || exit 1
702 fi
703 if [ -n "$LZMA_SRC" ]; then
704 cd $pkgdir/source
705 if [ "$(ls -A tmp | wc -l)" -gl 1 ] || [ -f "$(echo tmp/*)" ]; then
706 mv tmp tmp-1; mkdir tmp
707 mv tmp-1 tmp/${SOURCE:-$PACKAGE}-$VERSION
708 fi
709 if [ -d "tmp/${SOURCE:-$PACKAGE}-$VERSION" ]; then
710 cd tmp; tar -c * | lzma e $SRC/$TARBALL -si
711 fi
712 fi
713 cd $pkgdir/source/tmp
714 # Some archives are not well done and don't extract to one dir (ex lzma).
715 files=$(ls | wc -l)
716 [ "$files" == 1 ] && [ -d "$(ls)" ] && mv * ../$PACKAGE-$VERSION
717 [ "$files" == 1 ] && [ -f "$(ls)" ] && mkdir -p ../$PACKAGE-$VERSION && \
718 mv * ../$PACKAGE-$VERSION/$TARBALL
719 [ "$files" -gt 1 ] && mkdir -p ../$PACKAGE-$VERSION && \
720 mv * ../$PACKAGE-$VERSION
721 cd ..; rm -rf tmp
722 fi
724 # Libtool shared libs path hack.
725 case "$ARCH" in
726 arm*) cross libhack ;;
727 esac
729 # Execute receipt rules.
730 if grep -q ^compile_rules $receipt; then
731 _ 'Executing: %s' 'compile_rules'
732 echo "CFLAGS : $CFLAGS"
733 #echo "LDFLAGS : $LDFLAGS"
734 [ -d "$src" ] && cd $src
735 compile_rules $@ || exit 1
736 # Stay compatible with _pkg
737 [ -d "$src/_pkg" ] && mv $src/_pkg $install
738 # QA: compile_rules success so valid.
739 mkdir -p $install
740 else
741 # QA: no compile_rules so no error, valid.
742 mkdir -p $install
743 fi
744 separator; newline
746 # Execute testsuite.
747 if grep -q ^testsuite $receipt; then
748 _ 'Running testsuite'; separator
749 testsuite $@ || exit 1
750 separator; newline
751 fi
752 }
755 # Cook quality assurance.
757 cookit_quality() {
758 if [ ! -d "$WOK/$pkg/install" ] && [ -z "$WANTED" ]; then
759 _ 'ERROR: cook failed' | tee -a $LOGS/$pkg.log
760 fi
761 # ERROR can be echoed any time in cookit()
762 lerror=$(_n 'ERROR')
763 if grep -Ev "(conftest|configtest)" $LOGS/$pkg.log | \
764 grep -Eq "(^$lerror|undefined reference to)" ; then
765 debug_info | tee -a $LOGS/$pkg.log
766 rm -f $command
767 exit 1
768 fi
769 }
772 # Create the package. Wanted to use TazPkg to create a tazpkg package at first,
773 # but it doesn't handle EXTRAVERSION.
775 packit() {
776 set_paths
778 # Handle cross compilation
779 case "$ARCH" in
780 arm*|x86_64) arch="-$ARCH" ;;
781 esac
783 _ 'Pack: %s' "$PACKAGE $VERSION$arch"; separator
785 if grep -q ^genpkg_rules $receipt; then
786 _ 'Executing: %s' 'genpkg_rules'
787 set -e; cd $pkgdir; mkdir -p $fs
788 genpkg_rules || (newline; _ 'ERROR: genpkg_rules failed'; newline) >> \
789 $LOGS/$pkg.log
790 else
791 _ 'No packages rules: meta package'
792 mkdir -p $fs
793 fi
795 # First QA check to stop now if genpkg_rules failed.
796 lerror=$(_n 'ERROR')
797 if fgrep -q ^$lerror $LOGS/$pkg.log; then
798 exit 1
799 fi
801 cd $taz
802 for file in receipt description.txt; do
803 [ ! -f "../$file" ] && continue
804 _n 'Copying "%s"...' "$file"
805 cp -f ../$file $pack; chown 0.0 $pack/$file; status
806 done
807 copy_generic_files
809 # Strip and stuff files.
810 strip_package
812 # Create files.list with redirecting find output.
813 _n 'Creating the list of files...'
814 cd $fs
815 find . -type f -print > ../files.list
816 find . -type l -print >> ../files.list
817 cd ..; sed -i s/'^.'/''/ files.list
818 status
820 # Md5sum of files.
821 _n 'Creating md5sum of files...'
822 while read file; do
823 [ -L "fs$file" ] && continue
824 [ -f "fs$file" ] || continue
825 case "$file" in
826 /lib/modules/*/modules.*|*.pyc) continue ;;
827 esac
828 md5sum "fs$file" | sed 's/ fs/ /'
829 done < files.list > md5sum
830 status
832 UNPACKED_SIZE=$(du -chs fs receipt files.list md5sum description.txt \
833 2>/dev/null | awk 'END{ print $1 }')
835 # Build cpio archives.
836 _n 'Compressing the FS...'
837 find fs | cpio -o -H newc --quiet | lzma e fs.cpio.lzma -si
838 rm -rf fs
839 status
841 PACKED_SIZE=$(du -chs fs.cpio.lzma receipt files.list md5sum description.txt \
842 2>/dev/null | awk 'END{ print $1 }')
844 _n 'Updating receipt sizes...'
845 sed -i s/^PACKED_SIZE.*$// receipt
846 sed -i s/^UNPACKED_SIZE.*$// receipt
847 sed -i "s/^PACKAGE=/PACKED_SIZE=\"$PACKED_SIZE\"\nUNPACKED_SIZE=\"$UNPACKED_SIZE\"\nPACKAGE=/" receipt
848 status
850 # Set extra version.
851 if [ -n "$EXTRAVERSION" ]; then
852 _n 'Updating receipt EXTRAVERSION: %s' "$EXTRAVERSION"
853 sed -i s/^EXTRAVERSION.*$// receipt
854 sed -i "s/^VERSION=/EXTRAVERSION=\"$EXTRAVERSION\"\nVERSION=/" receipt
855 status
856 fi
858 # Compress.
859 _n 'Creating full cpio archive...'
860 find . -print | cpio -o -H newc --quiet > \
861 ../$PACKAGE-$VERSION$EXTRAVERSION$arch.tazpkg
862 status
864 _n 'Restoring original package tree...'
865 unlzma -c fs.cpio.lzma | cpio -idm --quiet
866 status
868 rm fs.cpio.lzma; cd ..
870 # QA and give info.
871 tazpkg=$(ls *.tazpkg)
872 packit_quality
873 separator; _ 'Package "%s" created' "$tazpkg"; newline
874 }
877 # Verify package quality and consistency.
879 packit_quality() {
880 #gettext "QA: checking for broken link..."
881 #link=$(find $fs/usr -type l -follow)
882 #[ "$link" ] && echo -e "\nERROR: broken link in filesystem"
883 #status
885 # Exit if any error found in log file.
886 lerror=$(_n 'ERROR')
887 if fgrep -q ^$lerror $LOGS/$pkg.log; then
888 rm -f $command
889 exit 1
890 fi
892 _n 'QA: checking for empty package...'
893 files=$(cat $WOK/$pkg/taz/$pkg-*/files.list | wc -l)
894 if [ "$files" == 0 ] && [ "$CATEGORY" != 'meta' ]; then
895 newline; _ 'ERROR: empty package'
896 rm -f $command
897 exit 1
898 else
899 # Ls sort by name so the first file is the one we want.
900 old=$(ls $PKGS/$pkg-*.tazpkg 2>/dev/null | head -n1)
901 status
902 if [ -f "$old" ]; then
903 _n 'Removing old package "%s"' "$(basename $old)"
904 rm -f $old; status
905 fi
906 mv -f $pkgdir/taz/$pkg-*.tazpkg $PKGS
907 sed -i /^${pkg}$/d $broken
908 #gettext "Removing source tree..."
909 #rm -f $WOK/$pkg/source && status
910 fi
911 }
914 # Reverse "cat" command: prints input lines in the reverse order
916 tac() {
917 sed '1!G;h;$!d' $1
918 }
921 # Install package on --install or update the chroot.
923 install_package() {
924 case "$ARCH" in
925 arm*|x86_64)
926 arch="-$ARCH"
927 root="$CROSS_TREE/sysroot" ;;
928 esac
929 # Install package if requested but skip install if target host doesn't
930 # match build system or it will break the build chroot.
931 build=$(echo $BUILD_SYSTEM | cut -d- -f1)
932 if [ -n "$inst" ] && [ "$build" == "$ARCH" ]; then
933 if [ -f "$PKGS/$PACKAGE-$VERSION$EXTRAVERSION.tazpkg" ]; then
934 cd $PKGS
935 tazpkg install $PACKAGE-$VERSION$EXTRAVERSION.tazpkg --forced
936 else
937 _ 'Unable to install package, build has failed.'; newline
938 exit 1
939 fi
940 fi
942 # Install package if part of the chroot to keep env up-to-date.
943 if [ -d "$root$INSTALLED/$pkg" ]; then
944 . /etc/slitaz/cook.conf
945 . $WOK/$pkg/taz/$pkg-*/receipt
946 _ 'Updating %s chroot environment...' "$ARCH"
947 _ 'Updating chroot: %s' "$pkg ($VERSION$EXTRAVERSION$arch)" | log
948 cd $PKGS
949 tazpkg install $pkg-$VERSION$EXTRAVERSION$arch.tazpkg --forced --root=$root
950 fi
951 }
954 # remove chroot jail
956 umount_aufs() {
957 tac ${1}rw/aufs-umount.sh | sh
958 rm -rf ${1}rw
959 umount ${1}root
960 rmdir ${1}r*
961 }
964 # Launch the cook command into a chroot jail protected by aufs.
965 # The current filesystems are used read-only and updates are
966 # stored in a separate branch.
968 try_aufs_chroot() {
970 base="/dev/shm/aufsmnt$$"
972 # Can we setup the chroot? Is it already done?
973 grep -q ^AUFS_NOT_SUPPORTED $receipt && return
974 grep -q ^AUFS_NOT_RAMFS $receipt && base="/mnt/aufsmnt$$"
975 [ -n "$AUFS_MOUNTS" -a ! -f /aufs-umount.sh ] || return
976 lsmod | grep -q aufs || modprobe aufs 2> /dev/null || return
977 mkdir ${base}root ${base}rw || return
979 _ 'Setup aufs chroot...'
981 # Sanity check
982 for i in / /proc /sys /dev/shm /home ; do
983 case " $AUFS_MOUNTS " in
984 *\ $i\ *) ;;
985 *) AUFS_MOUNTS="$AUFS_MOUNTS $i" ;;
986 esac
987 done
988 for mnt in $(ls -d $AUFS_MOUNTS | sort | uniq); do
989 mount --bind $mnt ${base}root$mnt
990 if [ $mnt == / ] && ! mount -t aufs -o br=${base}rw:/ none ${base}root; then
991 _ 'Aufs mount failure'
992 umount ${base}root
993 rm -rf ${base}r*
994 return
995 fi
996 echo "umount ${base}root$mnt" >> ${base}rw/aufs-umount.sh
997 done
998 trap "umount_aufs ${base}" INT
1000 chroot ${base}root $(cd $(dirname $0); pwd)/$(basename $0) "$@"
1001 status=$?
1003 _ 'Leaving aufs chroot...'
1004 umount_aufs $base
1005 # Install package outside the aufs jail
1006 install_package
1007 exit $status
1011 # Encode predefined XML entities
1013 xml_ent() {
1014 sed -e 's|&|\&amp;|g; s|<|\&lt;|g; s|>|\&gt;|g; s|"|\&quot;|g' -e "s|'|\&apos;|g"
1018 # Create a XML feed for freshly built packages.
1020 gen_rss() {
1021 pubdate=$(date '+%a, %d %b %Y %X')
1022 cat > $FEEDS/$pkg.xml <<EOT
1023 <item>
1024 <title>$PACKAGE $VERSION$EXTRAVERSION</title>
1025 <link>${COOKER_URL}?pkg=$PACKAGE</link>
1026 <guid>$PACKAGE-$VERSION$EXTRAVERSION</guid>
1027 <pubDate>$pubdate</pubDate>
1028 <description>$(echo -n "$SHORT_DESC" | xml_ent)</description>
1029 </item>
1030 EOT
1034 # Truncate stdout log file to $1 Mb.
1036 loglimit() {
1037 if [ -n "$DEFAULT_LOG_LIMIT" ]; then
1038 tee /dev/stderr | head -qc ${1:-$DEFAULT_LOG_LIMIT}m
1039 else
1040 tee /dev/stderr
1041 fi
1045 # Search file in mirrored packages
1047 search_file_mirror() {
1048 busybox unlzma -c $DB/files.list.lzma | grep $1\$ | cut -d: -f1 | sort -u
1052 # Search file in local wok packages
1054 search_file_local() {
1055 # existing packages have precedence over the package/taz folder
1056 srch=$1
1057 { for package in $(find $PKGS -name '*.tazpkg'); do
1058 if [ -n "$(busybox cpio --to-stdout --quiet -i files.list < $package | \
1059 grep /$srch\$)" ]; then
1060 busybox cpio -i receipt < $package | fgrep PACKAGE | cut -d\" -f2
1061 fi
1062 done } | sort -u
1066 # Ask in multiple choice
1068 ask_multiple() {
1069 local multiples first my_choice
1070 multiples="$1"
1071 first=$(echo "$multiples" | head -n1)
1072 newline; _ 'Multiple choice:'; echo "$multiples"; newline
1073 _ 'Select one [%s]: ' "$first"; read my_choice
1074 found="${my_choice:-$first}"
1078 # Search file in local cache (fast), local wok packages, mirrored packages
1080 search_file() {
1081 local srch cache missing
1082 srch="$1"
1083 cache='/var/cache/ldsearch.cache'
1084 missing='/var/cache/missing.file'
1085 touch $cache $missing
1086 found=$(grep $srch $cache | cut -d$'\t' -f2)
1087 if [ -z "$found" ]; then
1088 found=$(search_file_local $srch)
1089 if [ -n "$found" ]; then
1090 if [ $(echo "$found" | wc -l) -gt 1 ]; then
1091 ask_multiple "$found"
1092 fi
1093 echo -e "$srch\t$found" >> $cache
1094 else
1095 found=$(search_file_mirror $srch)
1096 if [ -n "$found" ]; then
1097 if [ $(echo "$found" | wc -l) -gt 1 ]; then
1098 ask_multiple "$found"
1099 fi
1100 echo -e "$srch\t$found" >> $cache
1101 else
1102 echo "$srch" >> $missing
1103 fi
1104 fi
1105 fi
1109 # Return size of file in human readible format
1110 # Note, "du" in opposite returns size occupied by file on disk (4KB multiple in most cases)
1111 filesize() {
1112 busybox ls -lh "$1" | awk '{print $5 "B"}'
1117 # Receipt functions to ease packaging
1120 get_dev_files() {
1121 _n 'Getting standard devel files...'
1122 mkdir -p $fs/usr/lib
1123 cp -a $install/usr/lib/pkgconfig $fs/usr/lib
1124 cp -a $install/usr/lib/*a $fs/usr/lib
1125 cp -a $install/usr/include $fs/usr
1126 status
1129 dblog() { tee -a $LOGS/pkgdb.log; }
1135 # Commands
1138 case "$1" in
1139 usage|help|-u|-h)
1140 usage ;;
1142 list-wok)
1143 newline; _ 'List of %s packages in "%s"' "$ARCH" "$WOK"; separator
1144 cd $WOK
1145 if [ "$ARCH" != 'i486' ]; then
1146 count=0
1147 for pkg in $(fgrep 'HOST_ARCH=' */receipt | egrep "$ARCH|any" | cut -d: -f1)
1148 do
1149 unset HOST_ARCH
1150 . $pkg
1151 count=$(($count + 1))
1152 colorize 34 "$PACKAGE"
1153 done
1154 else
1155 count=$(ls | wc -l)
1156 ls -1
1157 fi
1158 separator
1159 _p '%s package' '%s packages' "$count" "$(colorize 32 "$count")"
1160 newline ;;
1162 activity)
1163 cat $activity ;;
1165 search)
1166 # Just a simple search function, we dont need more actually.
1167 query="$2"
1168 newline; _ 'Search results for "%s"' "$query"; separator
1169 cd $WOK; ls -1 | grep "$query"
1170 separator; newline ;;
1172 setup)
1173 # Setup a build environment
1174 check_root
1175 _ 'Cook: setup environment' | log
1176 newline; _ 'Setting up your environment'; separator
1177 cd $SLITAZ
1178 init_db_files
1179 _ 'Checking for packages to install...'
1180 # Use setup pkgs from cross.conf or cook.conf. When cross compiling
1181 # ARCH-setup or 'cross check' should be used before: cook setup
1182 case "$ARCH" in
1183 arm*|x86_64)
1184 if [ ! -x '/usr/bin/cross' ]; then
1185 _ 'ERROR: %s is not installed' 'cross'
1186 exit 1
1187 fi
1188 _ 'Using config file: %s' '/etc/slitaz/cross.conf'
1189 . /etc/slitaz/cross.conf ;;
1190 esac
1191 for pkg in $SETUP_PKGS; do
1192 if [ -n "$forced" ]; then
1193 tazpkg -gi $pkg --forced
1194 else
1195 [ ! -d "$INSTALLED/$pkg" ] && tazpkg get-install $pkg
1196 fi
1197 done
1199 # Handle --options
1200 case "$2" in
1201 --wok) hg clone $WOK_URL wok || exit 1 ;;
1202 --stable) hg clone $WOK_URL-stable wok || exit 1 ;;
1203 --undigest) hg clone $WOK_URL-undigest wok || exit 1 ;;
1204 --tiny) hg clone $WOK_URL-tiny wok || exit 1 ;;
1205 esac
1207 # SliTaz group and permissions
1208 if ! grep -q ^slitaz /etc/group; then
1209 _ 'Adding group "%s"' 'slitaz'
1210 addgroup slitaz
1211 fi
1212 _ 'Setting permissions for group "%s"...' 'slitaz'
1213 find $SLITAZ -maxdepth 2 -exec chown root.slitaz {} \;
1214 find $SLITAZ -maxdepth 2 -exec chmod g+w {} \;
1215 separator; _ 'All done, ready to cook packages :-)'; newline ;;
1217 *-setup)
1218 # Setup for cross compiling.
1219 arch="${1%-setup}"
1220 check_root
1221 . /etc/slitaz/cook.conf
1222 for pkg in $CROSS_SETUP; do
1223 if [ -n "$forced" ]; then
1224 tazpkg -gi $pkg --forced
1225 else
1226 [ ! -d "$INSTALLED/$pkg" ] && tazpkg -gi $pkg
1227 fi
1228 done
1230 _ 'Cook: setup %s cross environment' "$arch" | log
1231 newline; boldify $(_n 'Setting up your %s cross environment' "$arch"); separator
1232 init_db_files
1233 sed -i \
1234 -e s"/ARCH=.*/ARCH=\"$arch\"/" \
1235 -e s"/CROSS_TREE=.*/CROSS_TREE=\"\/cross\/$arch\"/" \
1236 -e s'/BUILD_SYSTEM=.*/BUILD_SYSTEM=i486-slitaz-linux/' \
1237 /etc/slitaz/cook.conf
1238 case "$arch" in
1239 arm)
1240 flags='-O2 -march=armv6'
1241 host="$ARCH-slitaz-linux-gnueabi" ;;
1242 armv6hf)
1243 flags='-O2 -march=armv6j -mfpu=vfp -mfloat-abi=hard'
1244 host="$ARCH-slitaz-linux-gnueabi" ;;
1245 armv7)
1246 flags='-Os -march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=softfp -pipe'
1247 host="$ARCH-slitaz-linux-gnueabi" ;;
1248 x86_64)
1249 flags='-O2 -mtune=generic -pipe'
1250 host="$ARCH-slitaz-linux" ;;
1251 esac
1252 sed -i \
1253 -e s"/CFLAGS=.*/CFLAGS=\"$flags\"/" \
1254 -e s"/HOST_SYSTEM=.*/HOST_SYSTEM=$host/" /etc/slitaz/cook.conf
1255 . /etc/slitaz/cook.conf
1256 sysroot="$CROSS_TREE/sysroot"
1257 tools="/cross/$arch/tools"
1258 root="$sysroot"
1259 # L10n: keep the same width of translations to get a consistent view
1260 _ 'Target arch : %s' "$ARCH"
1261 _ 'Configure args : %s' "$CONFIGURE_ARGS"
1262 _ 'Build flags : %s' "$flags"
1263 _ 'Arch sysroot : %s' "$sysroot"
1264 _ 'Tools prefix : %s' "$tools/bin"
1265 # Tell the packages manager where to find packages.
1266 _ 'Packages DB : %s' "$root$DB"
1267 mkdir -p $root$INSTALLED
1268 cd $root$DB; rm -f *.bak
1269 for list in packages.list packages.desc packages.equiv packages.md5; do
1270 rm -f $list
1271 ln -s $SLITAZ/packages/$list $list
1272 done
1273 # We must have the cross compiled glibc-base installed or default
1274 # i486 package will be used as dep by tazpkg and then break the
1275 # cross environment
1276 if [ ! -f "$root$INSTALLED/glibc-base/receipt" ]; then
1277 colorize 36 $(_ 'WARNING: %s is not installed in sysroot' '(e)glibc-base')
1278 fi
1279 # Show GCC version or warn if not yet compiled.
1280 if [ -x "$tools/bin/$HOST_SYSTEM-gcc" ]; then
1281 _ 'Cross compiler : %s' "$HOST_SYSTEM-gcc"
1282 else
1283 colorize 36 $(_ 'C compiler "%s" is missing' "$HOST_SYSTEM-gcc")
1284 _ 'Run "%s" to cook a toolchain' 'cross compile'
1285 fi
1286 separator; newline ;;
1288 test)
1289 # Test a cook environment.
1290 _ 'Cook test: testing the cook environment' | log
1291 [ ! -d "$WOK" ] && exit 1
1292 [ ! -d "$WOK/cooktest" ] && cp -r $DATA/cooktest $WOK
1293 cook cooktest ;;
1295 new)
1296 # Create the package folder and an empty receipt.
1297 pkg="$2"
1298 [ -z "$pkg" ] && usage
1299 newline
1300 if [ -d "$WOK/$pkg" ]; then
1301 _ 'Package "%s" already exists.' "$pkg"
1302 exit 1
1303 fi
1305 _n 'Creating folder "%s"' "$WOK/$pkg"
1306 mkdir $WOK/$pkg; cd $WOK/$pkg; status
1308 _n 'Preparing the package receipt...'
1309 cp $DATA/receipt .
1310 sed -i s"/^PACKAGE=.*/PACKAGE=\"$pkg\"/" receipt
1311 status; newline
1313 # Interactive mode, asking and seding.
1314 case "$3" in
1315 --interactive|-x)
1316 _ 'Entering interactive mode...'
1317 separator
1318 _ 'Package : %s' "$pkg"
1320 _n 'Version : ' ; read answer
1321 sed -i s/'VERSION=\"\"'/"VERSION=\"$answer\""/ receipt
1323 _n 'Category : ' ; read answer
1324 sed -i s/'CATEGORY=\"\"'/"CATEGORY=\"$answer\""/ receipt
1326 # L10n: Short description
1327 _n 'Short desc : ' ; read answer
1328 sed -i s/'SHORT_DESC=\"\"'/"SHORT_DESC=\"$answer\""/ receipt
1330 _n 'Maintainer : ' ; read answer
1331 sed -i s/'MAINTAINER=\"\"'/"MAINTAINER=\"$answer\""/ receipt
1333 _n 'License : ' ; read answer
1334 sed -i s/'LICENSE=\"\"'/"LICENSE=\"$answer\""/ receipt
1336 _n 'Web site : ' ; read answer
1337 sed -i s#'WEB_SITE=\"\"'#"WEB_SITE=\"$answer\""# receipt
1338 newline
1340 # Wget URL.
1341 _ 'Wget URL to download source tarball.'
1342 _n 'Example : ' ; echo '$GNU_MIRROR/$PACKAGE/$TARBALL'
1343 _n 'Wget url : ' ; read answer
1344 sed -i "s|WGET_URL=.*|WGET_URL=\"$answer\"|" receipt
1346 # Ask for a stuff dir.
1347 confirm "$(_n 'Do you need a stuff directory? (y/N)')"
1348 if [ "$?" == 0 ]; then
1349 _n 'Creating the stuff directory...'
1350 mkdir $WOK/$pkg/stuff; status
1351 fi
1353 # Ask for a description file.
1354 confirm "$(_n 'Are you going to write a description? (y/N)')"
1355 if [ "$?" == 0 ]; then
1356 _n 'Creating the "%s" file...' 'description.txt'
1357 touch $WOK/$pkg/description.txt; status
1358 fi
1360 separator; _ 'Receipt is ready to use.'; newline ;;
1361 esac ;;
1363 list)
1364 # Cook a list of packages (better use the Cooker since it will order
1365 # packages before executing cook).
1366 check_root
1367 if [ -z "$2" ]; then
1368 newline; _ 'No list in argument.'; newline
1369 exit 1
1370 fi
1371 if [ ! -f "$2" ]; then
1372 newline; _ 'List "%s" not found.' "$2"; newline
1373 exit 1
1374 fi
1376 _ 'Starting cooking the list "%s"' "$2" | log
1378 for pkg in $(cat $2); do
1379 cook $pkg || broken
1380 done ;;
1382 clean-wok)
1383 check_root
1384 newline; _n 'Cleaning all packages files...'
1385 rm -rf $WOK/*/taz $WOK/*/install $WOK/*/source
1386 status; newline ;;
1388 clean-src)
1389 check_root
1390 newline; _n 'Cleaning all packages sources...'
1391 rm -rf $WOK/*/source
1392 status; newline ;;
1394 uncook)
1395 cd $WOK
1396 count=0
1397 newline; _ 'Checking for uncooked packages'; separator
1399 for pkg in *; do
1400 unset HOST_ARCH EXTRAVERSION
1401 [ ! -e $pkg/receipt ] && continue
1402 . $pkg/receipt
1403 # Source cooked pkg receipt to get EXTRAVERSION
1404 if [ -d "$WOK/$pkg/taz" ]; then
1405 cd $WOK/$pkg/taz/$pkg-*
1406 . receipt; cd $WOK
1407 fi
1408 case "$ARCH" in
1409 i486)
1410 debug "$(_ 'Package "%s"' "$PKGS/$PACKAGE-$VERSION$EXTRAVERSION.tazpkg")"
1411 if [ ! -f "$PKGS/$PACKAGE-$VERSION$EXTRAVERSION.tazpkg" ]; then
1412 count=$(($count + 1))
1413 colorize 34 "$pkg"
1414 fi ;;
1415 arm*)
1416 # Check only packages included in arch
1417 if echo "$HOST_ARCH" | egrep -q "$ARCH|any"; then
1418 # *.tazpkg
1419 if [ ! -f "$PKGS/$PACKAGE-$VERSION$EXTRAVERSION-$ARCH.tazpkg" ]; then
1420 count=$(($count + 1))
1421 colorize 34 "$pkg"
1422 fi
1423 fi ;;
1424 esac
1425 done
1427 if [ "$count" -gt "0" ]; then
1428 separator
1429 _p '%s uncooked package' '%s uncooked packages' "$count" "$(colorize 31 "$count")"
1430 else
1431 _ 'All packages are cooked :-)'
1432 fi
1433 newline ;;
1435 pkgdb)
1436 # Create suitable packages list for TazPKG and only for built packages
1437 # as well as flavors files for TazLiTo. We dont need logs since we do it
1438 # manually to ensure everything is fine before syncing the mirror.
1440 rm $LOGS/pkgdb.log 2>/dev/null
1442 case "$2" in
1443 --flavors|--rmpkg) ;;
1444 *)
1445 [ -n "$2" ] && PKGS="$2"
1446 if [ ! -d "$PKGS" ]; then
1447 { newline; _ "Packages directory \"%s\" doesn't exist" "$PKGS"; newline; } | dblog
1448 exit 1
1449 fi ;;
1450 esac
1452 time=$(date +%s)
1453 flavors="$SLITAZ/flavors"
1454 live="$SLITAZ/live"
1456 echo 'cook:pkgdb' > $command
1457 _ 'Cook pkgdb: Creating all packages lists' | log
1458 newline; { _ 'Creating lists for "%s"' "$PKGS"; separator; } | dblog
1460 { _ 'Cook pkgdb started: %s' "$(date "$(_ '+%%F %%R')")"; newline; } | dblog
1462 cd $PKGS
1463 rm -f packages.* extra.list
1464 touch packages.equiv
1466 _n 'Creating file "%s"' 'packages.list' | dblog
1467 ls -1 *.tazpkg | sed s'/.tazpkg//' > $PKGS/packages.list
1468 echo " ($(filesize $PKGS/packages.list))" | dblog
1470 _n 'Creating file "%s"' 'packages.md5' | dblog
1471 md5sum *.tazpkg > $PKGS/packages.md5
1472 echo " ($(filesize $PKGS/packages.md5))" | dblog
1473 cp $PKGS/packages.md5 $PKGS/packages.toremove # list of duplicates
1475 md5sum packages.md5 | cut -d' ' -f1 > ID
1476 ( cat ./ID | tr $'\n' ' '; date -ur ./ID +%s ) > IDs # md5 and timestamp
1478 _n 'Creating file "%s"' 'descriptions.txt' | dblog
1479 rm $PKGS/descriptions.txt 2>/dev/null
1480 for i in $(ls $WOK | sort); do
1481 if [ -e "$WOK/$i/description.txt" ]; then
1482 echo "$i" >> descriptions.txt
1483 cat "$WOK/$i/description.txt" | sed 's|^$| |' >> descriptions.txt
1484 echo >> descriptions.txt
1485 fi
1486 done
1487 echo " ($(filesize $PKGS/descriptions.txt))" | dblog
1490 _ 'Creating lists from "%s"' "$WOK" | dblog
1491 cd $WOK
1492 for pkg in *; do
1493 unset_receipt
1494 . $pkg/receipt
1495 # PACKED_SIZE and UNPACKED_SIZE are only in built receipt
1496 [ -s $pkg/taz/*/receipt ] && . $pkg/taz/*/receipt
1498 if [ -f "$PKGS/$PACKAGE-$VERSION$EXTRAVERSION.tazpkg" ] || \
1499 [ -f "$PKGS/$PACKAGE-$VERSION$EXTRAVERSION-$ARCH.tazpkg" ]; then
1501 # packages.desc lets us search easily in DB
1502 cat >> $PKGS/packages.desc <<EOT
1503 $PACKAGE | $VERSION$EXTRAVERSION | $SHORT_DESC | $CATEGORY | $WEB_SITE
1504 EOT
1506 # packages.txt used by tazpkg and tazpkg-web also to provide
1507 # a human readable package list with version and description.
1508 cat >> $PKGS/packages.txt <<EOT
1509 $PACKAGE
1510 $VERSION$EXTRAVERSION
1511 $SHORT_DESC
1512 $PACKED_SIZE ($UNPACKED_SIZE installed)
1514 EOT
1516 # packages.info combines TazPkg separate files
1517 # and will substitute them all
1518 SIZES=$(echo $PACKED_SIZE $UNPACKED_SIZE | sed 's|\.0||g')
1519 DEPENDS=$(echo $DEPENDS) # remove newlines from some receipts
1520 MD5="$(fgrep " $PACKAGE-$VERSION$EXTRAVERSION.tazpkg" $PKGS/packages.md5 | awk '{print $1}')"
1521 cat >> $PKGS/packages.info <<EOT
1522 $PACKAGE $VERSION$EXTRAVERSION $CATEGORY $SHORT_DESC $WEB_SITE $TAGS $SIZES $DEPENDS $MD5
1523 EOT
1525 # packages.equiv is used by tazpkg install to check depends.
1526 for i in $PROVIDE; do
1527 DEST=''
1528 echo $i | fgrep -q : && DEST="${i#*:}:"
1529 if grep -qs ^${i%:*}= $PKGS/packages.equiv; then
1530 sed -i "s/^${i%:*}=/${i%:*}=$DEST$PACKAGE /" \
1531 $PKGS/packages.equiv
1532 else
1533 echo "${i%:*}=$DEST$PACKAGE" >> $PKGS/packages.equiv
1534 fi
1535 done
1537 # files.list provides a list of all packages files.
1538 cat $pkg/taz/*/files.list | sed s/^/"$pkg: \0"/ >> \
1539 $PKGS/files.list
1541 # list of duplicates
1542 sed -i "/ $PACKAGE-$VERSION$EXTRAVERSION.tazpkg/d" $PKGS/packages.toremove
1543 else
1544 # if receipt variable HOST_ARCH absent/empty or contains ARCH
1545 if [ -z "$HOST_ARCH" -o "${HOST_ARCH/$ARCH/}" != "$HOST_ARCH" ]; then
1546 _ ' - absent: %s (%s)' "$PACKAGE-$VERSION$EXTRAVERSION.tazpkg" "$ARCH" | dblog
1547 fi
1548 fi
1549 done
1551 # Display list size.
1552 _ 'Done: %s (%s)' 'packages.desc' "$(filesize $PKGS/packages.desc)" | dblog
1553 _ 'Done: %s (%s)' 'packages.txt' "$(filesize $PKGS/packages.txt)" | dblog
1554 _ 'Done: %s (%s)' 'packages.info' "$(filesize $PKGS/packages.info)" | dblog
1555 _ 'Done: %s (%s)' 'packages.equiv' "$(filesize $PKGS/packages.equiv)" | dblog
1557 cd $PKGS
1560 # Check package duplicates
1561 if [ -s "$PKGS/packages.toremove" ]; then
1562 newline | dblog
1563 _ 'Removing duplicates:' | dblog
1564 while read pkgsum pkgfile; do
1565 echo " - $pkgfile" | dblog
1566 sed -i "/${pkgfile%.tazpkg}/d" $PKGS/packages.list
1567 sed -i "/ $pkgfile/d" $PKGS/packages.md5
1568 [ -n "$rmpkg" ] && rm $PKGS/$pkgfile # remove packages only with --rmpkg
1569 done < $PKGS/packages.toremove
1570 newline | dblog
1571 fi
1572 rm $PKGS/packages.toremove
1575 # files.list.lzma
1576 _n 'Creating file "%s"' 'files.list.lzma' | dblog
1577 touch files.list
1578 # pkgs.slitaz.org strongly depends on list sorted by packages names
1579 lzma e files.list files.list.lzma
1580 echo " ($(filesize $PKGS/files.list.lzma))" | dblog
1582 # Pre-sorting filenames causes 10% smaller resulting lzma file
1583 _n 'Creating file "%s"' 'files-list.lzma' | dblog
1584 cat files.list | sort -k2 -o files.list.sorted
1585 lzma e files.list.sorted files-list.lzma
1586 rm -f files.list files.list.sorted
1587 echo " ($(filesize $PKGS/files-list.lzma))" | dblog
1589 [ -e files.list.md5 ] && rm files.list.md5
1590 md5sum files-list.lzma | cut -d' ' -f1 | tr -d $'\n' > files-list.md5
1592 # packages.info.lzma
1593 PI=packages.info
1594 _n 'Creating file "%s"' 'packages.info.lzma' | dblog
1595 touch $PI
1596 lzma e $PI $PI.lzma
1597 echo " ($(filesize $PKGS/packages.info.lzma))" | dblog
1599 # Make bundle to fast recharge
1600 _n 'Creating file "%s"' 'bundle.tar.lzma' | dblog
1601 [ -f bundle.tar.lzma ] && rm bundle.tar.lzma
1602 # Make sure to get "mirrors" file
1603 until [ -e 'mirrors' ]; do
1604 wget -q http://mirror1.slitaz.org/mirrors
1605 echo -n '.' | dblog; sleep 5
1606 done
1607 # Make sure to get "extra.list" file
1608 until [ -e 'extra.list' ]; do
1609 wget -q -O extra.list http://mirror1.slitaz.org/packages/get.list
1610 echo -n '.' | dblog; sleep 5
1611 done
1612 busybox tar -chaf bundle.tar.lzma \
1613 mirrors extra.list files-list.md5 packages.info descriptions.txt \
1614 packages.desc packages.md5 packages.txt packages.list packages.equiv
1615 rm ./mirrors
1616 echo " ($(filesize $PKGS/bundle.tar.lzma))" | dblog
1618 # Display some info.
1619 separator | dblog
1620 nb=$(ls $PKGS/*.tazpkg | wc -l)
1621 time=$(($(date +%s) - $time))
1622 # L10n: 's' is for seconds (cooking time)
1623 { _ 'Packages: %s - Time: %ss' "$nb" "$time"; newline; } | dblog
1626 # Create all flavors files at once. Do we really need code to monitor
1627 # flavors changes? Lets just build them with packages lists before
1628 # syncing the mirror.
1629 [ "$2" != '--flavors' ] && exit 1
1631 if [ ! -d "$flavors" ]; then
1632 { _ 'Missing flavors folder "%s"' "$flavors"; newline; } | dblog
1633 exit 1
1634 fi
1636 [ ! -d "$live" ] && mkdir -p $live
1637 _ 'Creating flavors files in "%s"' "$live" | dblog
1638 _ 'Cook pkgdb: Creating all flavors' | log
1639 separator | dblog
1641 _ 'Recharging lists to use latest packages...' | dblog
1642 tazpkg recharge >/dev/null 2>/dev/null
1644 # We need a custom tazlito config to set working dir to /home/slitaz.
1645 if [ ! -f "$live/tazlito.conf" ]; then
1646 _ 'Creating configuration file "%s"' 'tazlito.conf' | dblog
1647 cp /etc/tazlito/tazlito.conf $live
1648 sed -i s@WORK_DIR=.*@WORK_DIR=\"/home/slitaz\"@ \
1649 $live/tazlito.conf
1650 fi
1652 # Update Hg flavors repo and pack.
1653 if [ -d "$flavors/.hg" ]; then
1654 cd $flavors; hg pull -u
1655 fi
1657 cd $live
1658 _ 'Starting to generate flavors...' | dblog
1659 rm -f flavors.list *.flavor
1660 for i in $flavors/*; do
1661 fl=$(basename $i)
1662 _ 'Packing flavor "%s"' "$fl" | dblog
1663 tazlito pack-flavor $fl >/dev/null || exit 1
1664 tazlito show-flavor $fl --brief --noheader 2>/dev/null >> flavors.list
1665 done
1666 cp -f $live/*.flavor $live/flavors.list $PKGS
1667 separator | dblog
1668 { _ 'Total flavors size: %s' "$(du -sh $live | awk '{print $1}')"; newline; } | dblog
1669 rm -f $command
1670 separator | dblog
1671 _ 'Cook pkgdb end: %s' "$(date "$(_ '+%%F %%R')")" | dblog
1672 ;;
1674 *)
1675 # Just cook and generate a package.
1676 check_root
1677 time=$(date +%s)
1678 pkg="$1"
1679 [ -z "$pkg" ] && usage
1680 lastcooktime=$(sed '/^Cook time/!d;s|.*: *\([0-9]*\)s.*|\1|' \
1681 $LOGS/$pkg.log 2> /dev/null)
1682 receipt="$WOK/$pkg/receipt"
1683 check_pkg_in_wok
1684 newline
1686 unset inst
1687 unset_receipt
1688 . $receipt
1690 # Handle cross compilation.
1691 case "$ARCH" in
1692 arm*)
1693 if [ -z "$HOST_ARCH" ]; then
1694 _ 'cook: HOST_ARCH is not set in "%s" receipt' "$pkg"
1695 error="$(_ 'package "%s" is not included in %s' "$pkg" "$ARCH")"
1696 _ 'cook: %s' "$error"
1697 [ -n "$CROSS_BUGS" ] && _ 'bugs: %s' "$CROSS_BUGS"
1698 _ 'Cook skip: %s' "$error" | log
1699 newline
1700 exit 1
1701 fi ;;
1702 esac
1704 # Some packages are not included in some arch or fail to cross compile.
1705 : ${HOST_ARCH=i486}
1706 debug "$(_ 'Host arch %s' "$HOST_ARCH")"
1707 # Handle arm{v6hf,v7,..}
1708 if ! $(echo "$HOST_ARCH" | egrep -q "${ARCH%v[0-9]*}|any"); then
1709 _ 'cook: %s' "HOST_ARCH=$HOST_ARCH"
1710 error="$(_ "package \"%s\" doesn't cook or is not included in %s" "$pkg" "$ARCH")"
1711 _ 'cook: %s' "error"
1712 [ -n "$CROSS_BUGS" ] && _ 'bugs: %s' "$CROSS_BUGS"
1713 _ 'Cook skip: %s' "$error" | log
1714 sed -i /^${pkg}$/d $broken
1715 newline
1716 exit 0
1717 fi
1719 # Skip blocked, 3 lines also for the Cooker.
1720 if grep -q "^$pkg$" $blocked && [ "$2" != '--unblock' ]; then
1721 _ 'Package "%s" is blocked' "$pkg"; newline
1722 exit 0
1723 fi
1725 try_aufs_chroot "$@"
1727 # Log and source receipt.
1728 _ 'Cook started for: %s' "<a href='cooker.cgi?pkg=$pkg'>$pkg</a>" | log
1729 echo "cook:$pkg" > $command
1730 [ "$lastcooktime" ] &&
1731 echo "cook:$pkg $lastcooktime $(date +%s)" > $cooktime
1733 # Display and log info if cook process stopped.
1734 # FIXME: gettext not working (in single quotes) here!
1735 trap '_ "\n\nCook stopped: control-C\n\n" | \
1736 tee -a $LOGS/$pkg.log' INT
1738 # Handle --options
1739 case "$2" in
1740 --clean|-c)
1741 _n 'Cleaning "%s"' "$pkg"
1742 cd $WOK/$pkg; rm -rf install taz source
1743 status; newline
1744 exit 0 ;;
1746 --install|-i)
1747 inst='yes' ;;
1749 --getsrc|-gs)
1750 _ 'Getting source for "%s"' "$pkg"; separator
1751 get_source
1752 _ 'Tarball: %s' "$SRC/$TARBALL"; newline
1753 exit 0 ;;
1755 --block|-b)
1756 _n 'Blocking package "%s"' "$pkg"
1757 [ $(grep "^$pkg$" $blocked) ] || echo "$pkg" >> $blocked
1758 status; newline
1759 exit 0 ;;
1761 --unblock|-ub)
1762 _n 'Unblocking package "%s"' "$pkg"
1763 sed -i "/^${pkg}$/"d $blocked
1764 status; newline
1765 exit 0 ;;
1767 --pack)
1768 if [ -d $WOK/$pkg/taz ]; then
1769 rm -rf $WOK/$pkg/taz
1770 [ -f $LOGS/$pkg-pack.log ] && rm -rf $LOGS/$pkg-pack.log
1771 packit 2>&1 | tee -a $LOGS/$pkg-pack.log
1772 clean_log
1773 else
1774 _ 'Need to build "%s"' "$pkg"
1775 exit 0
1776 fi
1777 exit 0 ;;
1779 --cdeps)
1780 if [ ! -d $WOK/$pkg/taz ]; then
1781 _ 'Need to build "%s"' "$pkg"
1782 exit 0
1783 fi
1785 _ 'Checking depends'; separator
1786 lddlist='/tmp/lddlist'; touch $lddlist
1787 missing='/var/cache/missing.file'
1789 # find all deps using ldd
1790 for exe in $(find $WOK/$pkg/taz -type f -perm +111); do
1791 [ "x$(dd if=$exe bs=4 count=1 2>/dev/null)" == "xELF" ] &&
1792 ldd $exe | sed 's| ||' | cut -d' ' -f1 >> $lddlist
1793 done #"
1795 # remove exe/so duplicates
1796 sort -u $lddlist > $lddlist.sorted
1798 # search packages
1799 for exefile in $(cat $lddlist.sorted); do
1800 search_file $exefile
1801 echo "$found" >> $lddlist.pkgs
1802 echo -n '.'
1803 done
1804 echo
1806 # remove packages duplicates
1807 sort -u $lddlist.pkgs > $lddlist.final
1808 sort -u $missing > $missing.final
1809 rm -f $lddlist $lddlist.sorted $lddlist.pkgs $missing
1810 exit 0 ;;
1811 esac
1813 # Check if wanted is built now so we have separate log files.
1814 for wanted in $WANTED ; do
1815 if grep -q "^$wanted$" $blocked; then
1816 _ 'WANTED package "%s" is blocked' "$wanted" | tee $LOGS/$pkg.log
1817 newline
1818 rm -f $command
1819 exit 1
1820 fi
1821 if grep -q "^$wanted$" $broken; then
1822 _ 'WANTED package "%s" is broken' "$wanted" | tee $LOGS/$pkg.log
1823 newline
1824 rm -f $command
1825 exit 1
1826 fi
1827 if [ ! -d "$WOK/$wanted/install" ]; then
1828 cook "$wanted" || exit 1
1829 fi
1830 done
1832 # Cook and pack or exit on error and log everything.
1833 cookit $@ 2>&1 | loglimit 50 > $LOGS/$pkg.log
1834 remove_deps | tee -a $LOGS/$pkg.log
1835 cookit_quality
1836 packit 2>&1 | loglimit 5 >> $LOGS/$pkg.log
1837 clean_log
1839 # Exit if any error in packing.
1840 lerror=$(_n 'ERROR')
1841 if grep -Ev "(/root/.cvspass|conftest|df: /|rm: can't remove)" $LOGS/$pkg.log | \
1842 grep -Eq "(^$lerror|: No such file or directory|not remade because of errors|ake: \*\*\* .* Error)"; then
1843 debug_info | tee -a $LOGS/$pkg.log
1844 rm -f $command
1845 exit 1
1846 fi
1848 # Create an XML feed
1849 gen_rss
1851 # Time and summary
1852 time=$(($(date +%s) - $time))
1853 summary | tee -a $LOGS/$pkg.log
1854 newline
1856 # We may want to install/update (outside aufs jail !).
1857 [ -s /aufs-umount.sh ] ||
1858 install_package
1860 # Finally we DON'T WANT to build the *-dev or packages with WANTED="$pkg"
1861 # You want automation: use the Cooker Build Bot.
1862 rm -f $command ;;
1863 esac
1865 exit 0